<template>
  <div class="semester-manage">
    <div class="part-box part-box-filter part-box-flex">
      <div>
        <el-button
          v-if="checkPrivilege('button', 'select')"
          type="primary"
          @click="toPage(1)"
          >查询</el-button
        >
      </div>
      <div class="part-box-action">
        <el-button
          v-if="checkPrivilege('button', 'add')"
          type="primary"
          icon="el-icon-circle-plus-outline"
          @click="toAdd"
          >新增</el-button
        >
      </div>
    </div>
    <div class="part-box part-box-pad">
      <el-table ref="TableList" :data="dataList">
        <el-table-column
          type="index"
          label="序号"
          width="70"
          :index="indexMethod"
        ></el-table-column>
        <el-table-column
          prop="semesterName"
          label="学期"
          min-width="210"
        ></el-table-column>
        <el-table-column prop="enable" label="状态" width="80">
          <template slot-scope="scope">
            {{ scope.row.enable | enableFilter }}
          </template>
        </el-table-column>
        <el-table-column class-name="action-column" label="操作" width="140">
          <template slot-scope="scope">
            <!-- <el-button
              v-if="checkPrivilege('link', 'edit')"
              class="btn-primary"
              type="text"
              @click="toEdit(scope.row)"
              >编辑</el-button
            > -->
            <el-button
              v-if="checkPrivilege('link', 'enable')"
              :class="scope.row.enable ? 'btn-danger' : 'btn-primary'"
              type="text"
              @click="toEnable(scope.row)"
              >{{ scope.row.enable ? "禁用" : "启用" }}</el-button
            >
            <el-button
              v-if="checkPrivilege('link', 'delete')"
              class="btn-danger"
              type="text"
              @click="toDelete(scope.row)"
              >删除</el-button
            >
          </template>
        </el-table-column>
      </el-table>
      <div class="part-page">
        <el-pagination
          background
          layout="total, sizes, prev, pager, next, jumper"
          :pager-count="5"
          :current-page="current"
          :total="total"
          :page-size="size"
          @current-change="toPage"
          @size-change="pageSizeChange"
        >
        </el-pagination>
      </div>
    </div>

    <modify-semester
      :instance="curRow"
      @modified="getList"
      ref="ModifySemester"
    ></modify-semester>
  </div>
</template>

<script>
import { semesterListQuery, deleteSemester, ableSemester } from "../api";
import ModifySemester from "../components/ModifySemester";

export default {
  name: "semester-manage",
  components: { ModifySemester },
  data() {
    return {
      filter: {},
      current: 1,
      size: this.GLOBAL.pageSize,
      total: 0,
      dataList: [],
      curRow: {},
    };
  },
  mounted() {
    this.getList();
  },
  methods: {
    async getList() {
      if (!this.checkPrivilege("list", "list")) return;

      const datas = {
        ...this.filter,
        pageNumber: this.current,
        pageSize: this.size,
      };
      const data = await semesterListQuery(datas);
      this.dataList = data.records;
      this.total = data.total;
    },
    toPage(page) {
      this.current = page;
      this.getList();
    },
    toAdd() {
      this.curRow = {};
      this.$refs.ModifySemester.open();
    },
    toEdit(row) {
      this.curRow = row;
      this.$refs.ModifySemester.open();
    },
    async toDelete(row) {
      const result = await this.$confirm(
        `确定要删除学期【${row.semesterName}】吗?`,
        "提示",
        {
          type: "warning",
        }
      ).catch(() => {});
      if (result !== "confirm") return;

      await deleteSemester(row.id);
      this.$message.success("删除成功！");
      this.deletePageLastItem();
    },
    async toEnable(row) {
      const action = row.enable ? "禁用" : "启用";
      const result = await this.$confirm(
        `确定要${action}学期【${row.semesterName}】吗?`,
        "提示",
        {
          type: "warning",
        }
      ).catch(() => {});
      if (result !== "confirm") return;

      const enable = !row.enable;
      await ableSemester({
        id: row.id,
        enable,
      });
      row.enable = enable;
      this.$message.success("操作成功！");
    },
  },
};
</script>
